/*
 * Copyright (c) 2005, John Mettraux, OpenWFE.org
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * . Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.  
 * 
 * . Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * 
 * . Neither the name of the "OpenWFE" nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: GoneParentId.java 1882 2005-05-17 16:41:07Z jmettraux $
 */

//
// GoneParentId.java
//
// john.mettraux@openwfe.org
//
// generated with 
// jtmpl 1.1.01 2004/05/19 (john.mettraux@openwfe.org)
//

package openwfe.org.engine.expressions;

/**
 * no comment
 *
 * <p><font size=2>CVS Info :
 * <br>$Author: jmettraux $
 * <br>$Id: GoneParentId.java 1882 2005-05-17 16:41:07Z jmettraux $ </font>
 *
 * @author john.mettraux@openwfe.org
 */
public final class GoneParentId

    extends FlowExpressionId

{

    //
    // CONSTANTS & co

    private final static String GONE = "gone";

    /**
     * This singleton is used by certain sync expressions (discriminator)
     * to inform an expression that it should not reply...
     */
    public final static FlowExpressionId GONE_PARENT_ID
        = new GoneParentId();

    //
    // FIELDS

    //
    // CONSTRUCTORS

    /**
     * A public constructor is required (for the XmlCoder)
     */
    public GoneParentId ()
    {
        super();

        super.setEngineId(GONE);
        super.setInitialEngineId(GONE);
        super.setWorkflowDefinitionUrl(GONE);
        super.setWorkflowDefinitionName(GONE);
        super.setWorkflowDefinitionRevision(GONE);
        super.setWorkflowInstanceId(null);
        super.setExpressionName(GONE);
        super.setExpressionId(null);
    }

    //
    // METHODS

    /*
    public final void setEngineId (String s) {}
    public final void setInitialEngineId (String s) {}
    public final void setWorkflowDefinitionUrl (String s) {}
    public final void setWorkflowDefinitionName (String s) {}
    public final void setWorkflowDefinitionRevision (String s) {}
    public final void setWorkflowInstanceId (String s) {}
    public final void setExpressionName (String s) {}
    public final void setExpressionId (String s) {}
    */

    //
    // STATIC METHODS

}
