/*
 * Copyright (c) 2005, John Mettraux, OpenWFE.org
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * . Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.  
 * 
 * . Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * 
 * . Neither the name of the "OpenWFE" nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: IncrementExpression.java 2265 2005-12-09 07:02:26Z jmettraux $
 */

//
// IncrementExpression.java
//
// jmettraux@openwfe.org
//
// generated with 
// jtmpl 1.0.04 31.10.2002 John Mettraux (jmettraux@openwfe.org)
//

package openwfe.org.engine.expressions;

import openwfe.org.MapUtils;
import openwfe.org.engine.workitem.InFlowWorkItem;
import openwfe.org.engine.workitem.StringAttribute;


/**
 * Sets the value of a variable in the scope of the PARENT expression
 *
 * This expression uses ValueUtils a lot.
 *
 * @see ValueUtils
 *
 * <p><font size=2>CVS Info :
 * <br>$Author: jmettraux $
 * <br>$Date: 2005-12-09 08:02:26 +0100 (Fri, 09 Dec 2005) $
 * <br>$Id: IncrementExpression.java 2265 2005-12-09 07:02:26Z jmettraux $ </font>
 *
 * @author jmettraux@openwfe.org
 */
public class IncrementExpression

    extends ZeroChildExpression

{

    private final static org.apache.log4j.Logger log = org.apache.log4j.Logger
        .getLogger(IncrementExpression.class.getName());

    //
    // CONSTANTS
    
    //
    // FIELDS

    //
    // CONSTRUCTORS

    //
    // METHODS

    public void apply (final InFlowWorkItem wi)
        throws ApplyException
    {
        try
        {
            //
            // determine value

            Object value = "1";
            try
            {
                value = ValueUtils.determineValue(this, wi);
            }
            catch (final ValueException e)
            {
                //throw new ApplyException
                //    ("Failed to determine value", ve);

                // value stays at 1 (default)
            }

            //
            // do the job

            try
            {
                ValueUtils.determineAndIncrementTarget
                    (this,
                     wi,
                     value);
            }
            catch (final ValueException e)
            {
                throw new ApplyException
                    ("Failed to set value", e);
            }

            //
            // reply

            replyToParent(wi);
        }
        catch (final ReplyException re)
        {
            throw new ApplyException
                ("Failed to reply to parent", re);
        }
    }
    
}
